
#	Skymeter, raadpleegt de Volumepagina van skynet selfcare,
#	verwerkt deze en bekomt de nuttige informatie.
#	
#	Copyright (C) 2003,2004,2005 Thomas Langewouters. 
#	
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#	
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use strict;
my $debug = 0;	# zet $debug = 1 bij het debuggen....
my $login;
my $password;
my $put_result;
my $update_url = "http://users.skynet.be/langewouters/skymeter_version.xml";
my $cookiefile = "/tmp/skymeter.cookie";
my $configfile = " $ENV{HOME}/.skymeterrc";

sub curl_get_url
{
	my $url = shift; 
	my $command = "$CURLBIN -k -s -L -b $cookiefile -c $cookiefile $url";
	return `$command`;
}

sub curl_post_url
{
	my $url = shift; my $postdata = shift;
	my $command ="$CURLBIN -k -s -L -c $cookiefile -b $cookiefile -d \"$postdata\" $url";
	return `$command`;
}

sub check_for_update
{
	print "Controleren op update...\n";
	my $webpage = curl_get_url($update_url);
	if ($debug)
	{
		print $webpage;
	}

	if ($webpage =~ /<xml>/) 
	{
		$webpage =~ /<currentversion>(.*)<\/currentversion>/;
	    	my $newest = $1;
	
		print "Huidige versie: $VERSION, recentste: $newest\n";
		$webpage =~ /<comment>(.*)<\/comment>/;
		my $comment = $1;
		print "Opmerkingen: $comment\n";

	} else {
		print "skymeter: FOUT: update-pagina niet gevonden\n";
	}
}

sub usage
{
	print <<"EOF";
Usage: 
% skymeter [OPTION]

Options:
  --help     Print this message
  --version  Print version information
  --update   Check the internet for an update
             (doesn't download or install new version)
  --put      Put the information in a file (to be read later)
Bug reports to: thomas.langewouters\@nospam.skynet.be
EOF
	exit(1);
}

sub version
{
 print <<"EOF";
Skymeter $VERSION 
EOF
 exit(1);
}

sub invalid
{
 print "Invalid usage. For help:\n";
 print "% hello --help\n";
 exit(1);
}

# Verwerk commandoregel 
# #####################
if ($#ARGV == 0)
{
 do version() if ($ARGV[0] eq "--version");
 do usage()   if ($ARGV[0] eq "--help");
 do check_for_update() if ($ARGV[0] eq "--update");
 do invalid();
}

if ($#ARGV >0)
{
	if ($ARGV[0] eq "--put")
	{
 		$put_result = $ARGV[1];
	}
}

# Lees configuratiebestand
# ########################
open(INFILE, $configfile) or die "Can't open configuration file: $!";
while (<INFILE>) 
{	#assigns each line in turn to $_ 
	if ($_ =~ /^user (.*)/) { $login = $1; }
	if ($_ =~ /^pass (.*)/) { $password = $1}
}
close (INFILE);

if ($debug)
{
	print "login: -$login-, password -$password-\n";
}

if (! $login || ! $password)
{
	die "skymeter: FOUT: No username or password given\n";
}

# Inloggen op website
# ###################
sub login {
	my $webpage;	
	# anders moeten we nog inloggen
	print "Inloggen... ";
	my $postdata="form_login=$login&form_password=$password&Langue_Id=2&fuseaction=CheckLoginConnection";
	$webpage = curl_post_url("https://e-care.skynet.be/Login/index.cfm", $postdata);
 
	if ($webpage =~ /Ziehier/)
	{
		return 1;
	}
	else
	{
		die "FOUT: authenticatie mislukt !!!\nControleer uw username/paswoord.  Indien u zeker bent dat deze correct zijn, controleer dan op een nieuwe versie van skymeter met het commando\"skymeter --update\"\n";	
	}

}
# Volumemeterpagina opvragen
# ##########################
sub requestvolumemeter {
	print "Volumemeter opvragen... ";
	my $webpage;
	$webpage =  curl_get_url("https://e-care.skynet.be/App/ConTime/index.cfm?fuseaction=VolumeMeter");

	if ($debug) 
	{
		open(OUTFILE, ">webpage.html") or die "Can't open webpage.html: $!";
		print OUTFILE $webpage;
		close (OUTFILE);
	}

	if ($webpage =~ /Ziehier/)
	{
		print "Authenticatie geslaagd!  ";
	}
	else
	{
		login();
		$webpage = requestvolumemeter();
	}
	return $webpage
}

# Cookiefile wissen
# #################
print `rm $cookiefile`;

# Volumemeterpagina verwerken
# ###########################
my $webpage = requestvolumemeter();
$webpage =~ /Gebruikt volume voor deze maand <font class="thirdlevel">\s*(\d*\.*\d*) GB<\/font> van de beschikbare (\d+) GB/;
    
my $basis_used = $1;
my $basis_total = $2;

$webpage =~ /Gebruikt Extra Volume <font class="thirdlevel">\s*(\d*\.*\d*) GB<\/font> van de beschikbare (\d+) GB/;
my $volumepack_used = $1;
my $volumepack_total = $2;

if ($basis_total == "")
{
	print "\nFOUT: bij het verwerken van de pagina !!!\nDe structuur van de volumemeter webpagina is gewijzigd!!!\n";
	check_for_update();
	exit(1);
}
else
{
	print "Pagina verwerkt!\n";
}

# Resultaten tonen op de gewenste manier
# ######################################

if ($put_result)
{
	# Plaats de informatie in een bestand.
	
	open(OUTFILE, ">$put_result") or die "Can't open $put_result: $!";
	print OUTFILE "Basisvolume: $basis_used / $basis_total\n";
	print OUTFILE "Volumepack: $volumepack_used / $volumepack_total\n";
	close (OUTFILE);
}
else
{
	# Toon informatie aan de gebruiker
	
	if ($basis_used / $basis_total == 1) 
	{
		print "Volledig basisvollume gebruikt \n";
	} 
	else
	{
		print "Basisvolume [$basis_used / $basis_total] \n";
	}

	if ($webpage =~ /Huidig Volume Pack :/) 
	{
		print "Lopende volumepack: [$volumepack_used / $volumepack_total]\n";
	}
	else
	{
		print "U beschikt niet over een volumepack\n";
	}
}
